// HKHSetting.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>
#include <commdlg.h>
#include "HKHSetting.h"
#include "HKHCommon.h"

/* Defines */
#define GSGETFILE_DLLNAME	_T("gsgetfile.dll")
#define GSGETOPENFILENAME	_T("gsGetOpenFileName")

#define MAX_LOADSTRING 100

/* Typedefs */
typedef BOOL (* PFNGETOPENFILENAME) (OPENFILENAME*);
typedef BOOL (* PFNGETSAVEFILENAME) (OPENFILENAME*);

typedef struct _DBLCLICKSETTINGS
{
	LPTSTR	pOffHookCmd2;
	LPTSTR	pOffHookArg2;
	LPTSTR	pOnHookCmd2;
	LPTSTR	pOnHookArg2;
	LPTSTR	pOffHookCmd3;
	LPTSTR	pOffHookArg3;
	LPTSTR	pOnHookCmd3;
	LPTSTR	pOnHookArg3;
	DWORD	dwPressInterval;
} DBLCLICKSETTINGS;

/* Global Variables */
HINSTANCE			g_hInst		= NULL;
HWND				g_hwndCB	= NULL;
HWND				g_hwndCB2	= NULL;
static SHACTIVATEINFO s_sai;

// Forward declarations of functions included in this code module:
LRESULT CALLBACK	DialogProc (HWND, UINT, WPARAM, LPARAM);
LRESULT	CALLBACK	DblClickDlgProc (HWND, UINT, WPARAM, LPARAM);

static
BOOL
GetOpenFileNameEx(OPENFILENAME* pofn)
{
	BOOL				bRet = FALSE;
	HINSTANCE			hModule = NULL;
	PFNGETOPENFILENAME	pfnGetOpenFileName = NULL;

	bRet = FALSE;

	hModule =  LoadLibrary(GSGETFILE_DLLNAME);
	if (hModule != NULL) {
		pfnGetOpenFileName = (PFNGETOPENFILENAME)GetProcAddress(hModule, GSGETOPENFILENAME);
	}

	if (pfnGetOpenFileName != NULL) {
		bRet = (*pfnGetOpenFileName)(pofn);
	}
	else {
		bRet = GetOpenFileName(pofn);
	}

	if (hModule != NULL) {
		FreeLibrary(hModule);
		hModule = NULL;
		pfnGetOpenFileName = NULL;
	}

	return bRet;
}

static
BOOL
ReadSettingsString(
	LPTSTR	pValueName,
	LPTSTR	pStr,
	DWORD	dwStrSize
)
{
	BOOL	bRet;
	LONG	lResult;
	HKEY	hKey = NULL;

	bRet = FALSE;

	if (pValueName == NULL || pStr == NULL) {
		return FALSE;
	}

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);

	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType = 0;
		DWORD	dwSize = 0;

		dwSize = dwStrSize;
		lResult = RegQueryValueEx(hKey, pValueName, NULL, &dwType, (LPBYTE)pStr, &dwSize);
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
BOOL
ReadSettingsDWORD(
	LPTSTR	pValueName,
	LPDWORD	pdwValue
)
{
	BOOL	bRet;
	LRESULT lResult;
	HKEY	hKey = NULL;

	bRet = FALSE;

	if (pValueName == NULL || pdwValue == NULL) {
		return FALSE;
	}

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);
	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType = REG_DWORD;
		DWORD	dwValue = 0;
		DWORD	dwSize = 0;

		dwSize = sizeof(dwValue);
		lResult = RegQueryValueEx(hKey, pValueName, NULL, &dwType, (LPBYTE)&dwValue, &dwSize);
		if (lResult == ERROR_SUCCESS) {
			*pdwValue = dwValue;
			bRet = TRUE;
		}

		CloseHandle(hKey);
		hKey = NULL;
	}

	return bRet;
}


static
BOOL
WriteSettingsString(
	LPTSTR	pValueName,
	LPTSTR	pStr
)
{
	BOOL	bRet;
	LONG	lResult;
	DWORD	dwDisposition;
	HKEY	hKey = NULL;

	bRet = FALSE;

	if (pValueName == NULL || pStr == NULL) {
		return FALSE;
	}

	lResult = RegCreateKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, _T(""), 0, 0, NULL, &hKey, &dwDisposition);

	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType = REG_SZ;
		DWORD	dwSize = 0;

		dwSize = (_tcslen(pStr) + 1)*sizeof(TCHAR);
		lResult = RegSetValueEx(hKey, pValueName, 0, dwType, (LPBYTE)pStr, dwSize);
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
BOOL
WriteSettingsDWORD(
	LPTSTR	pValueName,
	DWORD	dwValue
)
{
	BOOL	bRet;
	LONG	lResult;
	DWORD	dwDisposition;
	HKEY	hKey = NULL;

	bRet = FALSE;

	if (pValueName == NULL) {
		return FALSE;
	}

	lResult = RegCreateKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, _T(""), 0, 0, NULL, &hKey, &dwDisposition);

	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType = REG_DWORD;
		DWORD	dwSize = 0;

		dwSize = sizeof(dwValue);
		lResult = RegSetValueEx(hKey, pValueName, 0, dwType, (LPBYTE)&dwValue, dwSize);
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}


static
BOOL
DeleteSettings(
	LPTSTR	pValueName
)
{
	BOOL	bRet;
	LONG	lResult;
	HKEY	hKey = NULL;

	bRet = FALSE;

	if (pValueName == NULL) {
		return FALSE;
	}

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, HOOKKEYHOOK_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);

	if (lResult == ERROR_SUCCESS) {

		lResult = RegDeleteValue(hKey, pValueName);
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
BOOL
IsBlankString(
	LPTSTR	pStr
)
{
	BOOL	bRet;
	LPTSTR	p;

	bRet = TRUE;

	if (pStr == NULL) {
		return TRUE;
	}

	for (p = pStr; *p != TEXT('\0'); p++) {
		if (*p != TEXT(' ')) {
			bRet = FALSE;
			break;
		}
	}

	return bRet;
}

static
LPTSTR
DupString(
	LPTSTR	pStr
)
{
	LPTSTR	pRetStr = NULL;

	if (pStr != NULL) {
		int nLen = _tcslen(pStr);

		pRetStr = (LPTSTR)malloc((nLen + 1) * sizeof(TCHAR));
		if (pRetStr != NULL) {
			_tcscpy(pRetStr, pStr);
		}
	}

	return pRetStr;
}



static
void
ClearDblClickSettings(
  DBLCLICKSETTINGS* pSettings
)
{
	if (pSettings != NULL) {
		// ʘb{^(_uNbN)
		if (pSettings->pOffHookCmd2 != NULL){
			free(pSettings->pOffHookCmd2);
			pSettings->pOffHookCmd2 = NULL;
		}

		if (pSettings->pOffHookArg2 != NULL){
			free(pSettings->pOffHookArg2);
			pSettings->pOffHookArg2 = NULL;
		}
		//

		// Ib{^(_uNbN)
		if (pSettings->pOnHookCmd2 != NULL){
			free(pSettings->pOnHookCmd2);
			pSettings->pOnHookCmd2 = NULL;
		}

		if (pSettings->pOnHookArg2 != NULL){
			free(pSettings->pOnHookArg2);
			pSettings->pOnHookArg2 = NULL;
		}
		//

		// ʘb{^(gvNbN)
		if (pSettings->pOffHookCmd3 != NULL){
			free(pSettings->pOffHookCmd3);
			pSettings->pOffHookCmd3 = NULL;
		}

		if (pSettings->pOffHookArg3 != NULL){
			free(pSettings->pOffHookArg3);
			pSettings->pOffHookArg3 = NULL;
		}
		//

		// Ib{^(gvNbN)
		if (pSettings->pOnHookCmd3 != NULL){
			free(pSettings->pOnHookCmd3);
			pSettings->pOnHookCmd3 = NULL;
		}

		if (pSettings->pOnHookArg3 != NULL){
			free(pSettings->pOnHookArg3);
			pSettings->pOnHookArg3 = NULL;
		}
		//
	}
}

static
DBLCLICKSETTINGS*
LoadDblClickSettings(
)
{
	DBLCLICKSETTINGS*	pSettings = NULL;
	TCHAR	szSetting[MAX_PATH + 1];

	pSettings = (DBLCLICKSETTINGS*)malloc(sizeof(DBLCLICKSETTINGS));

	if (pSettings != NULL) {
		TCHAR	szValueName[32];

		memset(pSettings, 0, sizeof(DBLCLICKSETTINGS));

		// ʘb{^(_uNbN)
		wsprintf(szValueName, HOOKKEYHOOK_OFFHOOK_NTH_PATH, 2);
		memset(szSetting, 0, sizeof(szSetting));
		if (ReadSettingsString(szValueName, szSetting, sizeof(szSetting))){
			pSettings->pOffHookCmd2 = DupString(szSetting);
		}

		wsprintf(szValueName, HOOKKEYHOOK_OFFHOOK_NTH_ARG, 2);
		memset(szSetting, 0, sizeof(szSetting));
		if (ReadSettingsString(szValueName, szSetting, sizeof(szSetting))){
			pSettings->pOffHookArg2 = DupString(szSetting);
		}
		//

		// Ib{^(_uNbN)
		wsprintf(szValueName, HOOKKEYHOOK_ONHOOK_NTH_PATH, 2);
		memset(szSetting, 0, sizeof(szSetting));
		if (ReadSettingsString(szValueName, szSetting, sizeof(szSetting))){
			pSettings->pOnHookCmd2 = DupString(szSetting);
		}

		wsprintf(szValueName, HOOKKEYHOOK_ONHOOK_NTH_ARG, 2);
		memset(szSetting, 0, sizeof(szSetting));
		if (ReadSettingsString(szValueName, szSetting, sizeof(szSetting))){
			pSettings->pOnHookArg2 = DupString(szSetting);
		}
		//

		// ʘb{^(gvNbN)
		wsprintf(szValueName, HOOKKEYHOOK_OFFHOOK_NTH_PATH, 3);
		memset(szSetting, 0, sizeof(szSetting));
		if (ReadSettingsString(szValueName, szSetting, sizeof(szSetting))){
			pSettings->pOffHookCmd3 = DupString(szSetting);
		}

		wsprintf(szValueName, HOOKKEYHOOK_OFFHOOK_NTH_ARG, 3);
		memset(szSetting, 0, sizeof(szSetting));
		if (ReadSettingsString(szValueName, szSetting, sizeof(szSetting))){
			pSettings->pOffHookArg3 = DupString(szSetting);
		}
		//

		// Ib{^(gvNbN)
		wsprintf(szValueName, HOOKKEYHOOK_ONHOOK_NTH_PATH, 3);
		memset(szSetting, 0, sizeof(szSetting));
		if (ReadSettingsString(szValueName, szSetting, sizeof(szSetting))){
			pSettings->pOnHookCmd3 = DupString(szSetting);
		}

		wsprintf(szValueName, HOOKKEYHOOK_ONHOOK_NTH_ARG, 3);
		memset(szSetting, 0, sizeof(szSetting));
		if (ReadSettingsString(szValueName, szSetting, sizeof(szSetting))){
			pSettings->pOnHookArg3 = DupString(szSetting);
		}
		//

		// NbNԊu
		{
			DWORD	dwInterval = HOOKKEYHOOK_DEFAULT_PERIOD;
			if (ReadSettingsDWORD(HOOKKEYHOOK_PRESS_PERIOD, &dwInterval)) {
				pSettings->dwPressInterval = dwInterval;
			}
			else {
				pSettings->dwPressInterval = HOOKKEYHOOK_DEFAULT_PERIOD;
			}
		}
	}

	return pSettings;
}


static
void
SaveDblClickSettings(
	DBLCLICKSETTINGS*	pSettings
)
{
	if (pSettings != NULL) {
		TCHAR	szValueName[32];

		// ʘb{^(_uNbN)
		wsprintf(szValueName, HOOKKEYHOOK_OFFHOOK_NTH_PATH, 2);
		if (pSettings->pOffHookCmd2 != NULL) {
			WriteSettingsString(szValueName, pSettings->pOffHookCmd2);
		}
		else {
			DeleteSettings(szValueName);
		}

		wsprintf(szValueName, HOOKKEYHOOK_OFFHOOK_NTH_ARG, 2);
		if (pSettings->pOffHookArg2 != NULL) {
			WriteSettingsString(szValueName, pSettings->pOffHookArg2);
		}
		else {
			DeleteSettings(szValueName);
		}
		//

		// Ib{^(_uNbN)
		wsprintf(szValueName, HOOKKEYHOOK_ONHOOK_NTH_PATH, 2);
		if (pSettings->pOnHookCmd2 != NULL) {
			WriteSettingsString(szValueName, pSettings->pOnHookCmd2);
		}
		else {
			DeleteSettings(szValueName);
		}

		wsprintf(szValueName, HOOKKEYHOOK_ONHOOK_NTH_ARG, 2);
		if (pSettings->pOnHookArg2 != NULL) {
			WriteSettingsString(szValueName, pSettings->pOnHookArg2);
		}
		else {
			DeleteSettings(szValueName);
		}
		//

		// ʘb{^(gvNbN)
		wsprintf(szValueName, HOOKKEYHOOK_OFFHOOK_NTH_PATH, 3);
		if (pSettings->pOffHookCmd3 != NULL) {
			WriteSettingsString(szValueName, pSettings->pOffHookCmd3);
		}
		else {
			DeleteSettings(szValueName);
		}

		wsprintf(szValueName, HOOKKEYHOOK_OFFHOOK_NTH_ARG, 3);
		if (pSettings->pOffHookArg3 != NULL) {
			WriteSettingsString(szValueName, pSettings->pOffHookArg3);
		}
		else {
			DeleteSettings(szValueName);
		}
		//

		// Ib{^(gvNbN)
		wsprintf(szValueName, HOOKKEYHOOK_ONHOOK_NTH_PATH, 3);
		if (pSettings->pOnHookCmd3 != NULL) {
			WriteSettingsString(szValueName, pSettings->pOnHookCmd3);
		}
		else {
			DeleteSettings(szValueName);
		}

		wsprintf(szValueName, HOOKKEYHOOK_ONHOOK_NTH_ARG, 3);
		if (pSettings->pOnHookArg3 != NULL) {
			WriteSettingsString(szValueName, pSettings->pOnHookArg3);
		}
		else {
			DeleteSettings(szValueName);
		}
		//

		// NbNԊu
		if (pSettings->dwPressInterval != HOOKKEYHOOK_DEFAULT_PERIOD) {
			// ftHglƈقȂꍇ́Cl
			WriteSettingsDWORD(HOOKKEYHOOK_PRESS_PERIOD, pSettings->dwPressInterval);
		}
		else {
			DeleteSettings(HOOKKEYHOOK_PRESS_PERIOD);
		}
		//

	}
}

static
void
DiscardDblClickSettings(
	DBLCLICKSETTINGS* pSettings
)
{
	if (pSettings != NULL) {

		ClearDblClickSettings(pSettings);

		free(pSettings);
		pSettings = NULL;
	}
}

int
WINAPI
WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR    lpCmdLine,
	int       nCmdShow
)
{
	g_hInst = hInstance;
	DialogBox(hInstance, (LPCTSTR)IDD_HKHSETTING, NULL, (DLGPROC)DialogProc);
	return 0;
}

static
HWND
CreateRpCommandBar(
   HWND hwnd,
   UINT	uiResID
)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = uiResID;
	mbi.hInstRes   = g_hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	return mbi.hwndMB;
}

static
BOOL
HKHGetFileName(
	HWND	hDlg,		// IN
	LPTSTR	pFileName,	// OUT
	DWORD	dwSize		// IN	pFileName̕(I[܂)
)
{
	BOOL	bRet;
	OPENFILENAME	ofn;

	bRet = FALSE;

	if (pFileName == NULL) {
		return FALSE;
	}

	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hDlg;
	ofn.lpstrFile = pFileName;
	ofn.nMaxFile = dwSize;
	ofn.lpstrTitle = L"̧قJ...";
	ofn.lpstrFilter = L"ş (*.exe)\0*.exe\0SĂ̧ (*.*)\0*.*\0\0";
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST |OFN_PATHMUSTEXIST;
	ofn.lpstrInitialDir = NULL;

	bRet = GetOpenFileNameEx(&ofn);

	return bRet;
}

static
BOOL
IsLandscape()
{
	int		nWidth;
	int		nHeight;
	BOOL	bRet;

	bRet = FALSE;

	nWidth = GetSystemMetrics(SM_CXSCREEN);
	nHeight = GetSystemMetrics(SM_CYSCREEN);

	if (nWidth > nHeight) {
		bRet = TRUE;
	}

	return bRet;
}


static
LRESULT
CALLBACK
DialogProc(
   HWND hDlg,
   UINT message,
   WPARAM wParam,
   LPARAM lParam
)
{
	SHINITDLGINFO shidi;
	static DBLCLICKSETTINGS*	s_pSettings = NULL;

	switch (message)
	{
		case WM_INITDIALOG:
			{
				TCHAR	szSetting[MAX_PATH + 1];
				DWORD	dwValue = 0;

				// Create a Done button and size it.  
				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);

				//
				g_hwndCB = CreateRpCommandBar(hDlg, IDM_MENU);

				// ݒ̓ǂݍ
				// OffHook cmd
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_OFFHOOK_PATH, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT, _T(""));
				}

				// OffHook arg
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_OFFHOOK_ARG, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT, _T(""));
				}

				// OnHook cmd
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_ONHOOK_PATH, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT, _T(""));
				}

				// OnHook arg
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_ONHOOK_ARG, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT, _T(""));
				}
				//

				// SlideOpen cmd
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_SLIDEOPEN_PATH, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_SLIDEOPEN_PATH_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_SLIDEOPEN_PATH_EDIT, _T(""));
				}

				// SlideOpen arg
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_SLIDEOPEN_ARG, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_SLIDEOPEN_OPTION_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_SLIDEOPEN_OPTION_EDIT, _T(""));
				}

				// SlideClose cmd
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_SLIDECLOSE_PATH, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_SLIDECLOSE_PATH_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_SLIDECLOSE_PATH_EDIT, _T(""));
				}

				// SlideClose arg
				memset(szSetting, 0, sizeof(szSetting));
				if (ReadSettingsString(HOOKKEYHOOK_SLIDECLOSE_ARG, szSetting, sizeof(szSetting))){
					SetDlgItemText(hDlg, IDC_SLIDECLOSE_OPTION_EDIT, szSetting);
				}
				else {
					SetDlgItemText(hDlg, IDC_SLIDECLOSE_OPTION_EDIT, _T(""));
				}

				// ForceHookOffHook
				if (ReadSettingsDWORD(HOOKKEYHOOK_FORCEHOOK_OFFHOOK, &dwValue)) {
					if (dwValue != 0) {
						SendMessage(GetDlgItem(hDlg, IDC_CHECK_OFFHOOK), BM_SETCHECK, 1, 0);
					}
				}

				// ForceHookOnHook
				if (ReadSettingsDWORD(HOOKKEYHOOK_FORCEHOOK_ONHOOK, &dwValue)) {
					if (dwValue != 0) {
						SendMessage(GetDlgItem(hDlg, IDC_CHECK_ONHOOK), BM_SETCHECK, 1, 0);
					}
				}

				// _uNbNݒ{^̕\E\̐؂ւ
				if (IsLandscape()) {
					// 
					ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK1), SW_HIDE);
					ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK2), SW_SHOW);
				}
				else {
					// c
					ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK1), SW_SHOW);
					ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK2), SW_HIDE);
				}

				s_pSettings = LoadDblClickSettings();
			}
			return TRUE;
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case IDOK:
				{
					int		iRet;
					TCHAR	szSetting[MAX_PATH + 1];

					iRet = MessageBox(hDlg, _T("ݒ𔽉f܂H"), _T("HKHSetting"), MB_OK|MB_YESNO|MB_ICONQUESTION);
					if (iRet == IDYES) {

						// ݒ̏
						// OffHook cmd
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_OFFHOOK_PATH, szSetting);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_OFFHOOK_PATH);
						}

						// OffHook arg
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_OFFHOOK_ARG, szSetting);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_OFFHOOK_ARG);
						}

						// OnHook cmd
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_ONHOOK_PATH, szSetting);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_ONHOOK_PATH);
						}

						// OnHook arg
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_ONHOOK_ARG, szSetting);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_ONHOOK_ARG);
						}
						//

						// SlideOpen cmd
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_SLIDEOPEN_PATH_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_SLIDEOPEN_PATH, szSetting);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_SLIDEOPEN_PATH);
						}

						// SlideClose arg
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_SLIDEOPEN_OPTION_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_SLIDEOPEN_ARG, szSetting);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_SLIDEOPEN_ARG);
						}

						// SlideClose cmd
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_SLIDECLOSE_PATH_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_SLIDECLOSE_PATH, szSetting);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_SLIDECLOSE_PATH);
						}

						// SlideClose arg
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_SLIDECLOSE_OPTION_EDIT, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							WriteSettingsString(HOOKKEYHOOK_SLIDECLOSE_ARG, szSetting);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_SLIDECLOSE_ARG);
						}
						//

						// ForceHookOffHook
						if (IsDlgButtonChecked(hDlg, IDC_CHECK_OFFHOOK) == BST_CHECKED) {
							WriteSettingsDWORD(HOOKKEYHOOK_FORCEHOOK_OFFHOOK, 1);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_FORCEHOOK_OFFHOOK);
						}

						// ForceHookOnHook
						if (IsDlgButtonChecked(hDlg, IDC_CHECK_ONHOOK) == BST_CHECKED) {
							WriteSettingsDWORD(HOOKKEYHOOK_FORCEHOOK_ONHOOK, 1);
						}
						else {
							DeleteSettings(HOOKKEYHOOK_FORCEHOOK_ONHOOK);
						}

						// _uNbNݒ̏
						SaveDblClickSettings(s_pSettings);


						DiscardDblClickSettings(s_pSettings);
						s_pSettings = NULL;
						if (g_hwndCB != NULL) {
							CommandBar_Destroy(g_hwndCB);
							g_hwndCB = NULL;
						}

						EndDialog(hDlg, LOWORD(wParam));
					}
					
				}
				return TRUE;
				break;

			case IDCANCEL:

				DiscardDblClickSettings(s_pSettings);
				s_pSettings = NULL;

				if (g_hwndCB != NULL) {
					CommandBar_Destroy(g_hwndCB);
					g_hwndCB = NULL;
				}
				EndDialog(hDlg, LOWORD(wParam));

				return TRUE;
				break;

			case IDC_OFFHOOK_REF:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_OFFHOOK_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;

			case IDC_ONHOOK_REF:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_ONHOOK_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;

			case IDC_SLIDEOPEN_REF:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_SLIDEOPEN_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;

			case IDC_SLIDECLOSE_REF:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_SLIDECLOSE_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;
			case IDC_DBLCLICK1:
			case IDC_DBLCLICK2:
				{
					DialogBoxParam(g_hInst, (LPCTSTR)IDD_DBLCLICK, hDlg, (DLGPROC)DblClickDlgProc, (LPARAM)s_pSettings);

					// Ô
					if (IsLandscape()) {
						// 
						ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK1), SW_HIDE);
						ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK2), SW_SHOW);
					}
					else {
						// c
						ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK1), SW_SHOW);
						ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK2), SW_HIDE);
					}
				}
				return TRUE;
				break;
			}
			break;

		case WM_SETTINGCHANGE:
			if (wParam == SETTINGCHANGE_RESET) {
				if (IsLandscape()) {
					// 
					ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK1), SW_HIDE);
					ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK2), SW_SHOW);
				}
				else {
					// c
					ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK1), SW_SHOW);
					ShowWindow(GetDlgItem(hDlg, IDC_DBLCLICK2), SW_HIDE);
				}
			}
			break;
	}
    return FALSE;
}


static
LRESULT
CALLBACK
DblClickDlgProc(
   HWND hDlg,
   UINT message,
   WPARAM wParam,
   LPARAM lParam
)
{
	SHINITDLGINFO shidi;
	static DBLCLICKSETTINGS*	s_pSettings = NULL;

	switch (message)
	{
		case WM_INITDIALOG:
			{

				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);

				g_hwndCB2 = CreateRpCommandBar(hDlg, IDM_MENU2);

				// ݒ̓ǂݍ
				s_pSettings = (DBLCLICKSETTINGS*)lParam;
				if (s_pSettings != NULL) {
					// ʘb{^(_uNbN)
					if (s_pSettings->pOffHookCmd2 != NULL) {
						SetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT2, s_pSettings->pOffHookCmd2);
					}
					if (s_pSettings->pOffHookArg2 != NULL) {
						SetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT2, s_pSettings->pOffHookArg2);
					}

					// Ib{^(_uNbN)
					if (s_pSettings->pOnHookCmd2 != NULL) {
						SetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT2, s_pSettings->pOnHookCmd2);
					}
					if (s_pSettings->pOnHookArg2 != NULL) {
						SetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT2, s_pSettings->pOnHookArg2);
					}

					// ʘb{^(gvNbN)
					if (s_pSettings->pOffHookCmd3 != NULL) {
						SetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT3, s_pSettings->pOffHookCmd3);
					}
					if (s_pSettings->pOffHookArg3 != NULL) {
						SetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT3, s_pSettings->pOffHookArg3);
					}

					// Ib{^(gvNbN)
					if (s_pSettings->pOnHookCmd3 != NULL) {
						SetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT3, s_pSettings->pOnHookCmd3);
					}
					if (s_pSettings->pOnHookArg3 != NULL) {
						SetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT3, s_pSettings->pOnHookArg3);
					}

					// NbNԊu
					{
						TCHAR	szInterval[16];
						
						wsprintf(szInterval, _T("%d"), s_pSettings->dwPressInterval);
						SetDlgItemText(hDlg, IDC_PRESS_INTERVAL, szInterval);
					}

				}
			}
			return TRUE;
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case IDOK:
				{
					if (s_pSettings != NULL) {
						TCHAR	szSetting[MAX_PATH + 1];

						ClearDblClickSettings(s_pSettings);

						// Rg[ݒl擾

						// ʘb{^(_uNbN)
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT2, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							s_pSettings->pOffHookCmd2 = DupString(szSetting);
						}

						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT2, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							s_pSettings->pOffHookArg2 = DupString(szSetting);
						}
						//

						// Ib{^(_uNbN)
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT2, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							s_pSettings->pOnHookCmd2 = DupString(szSetting);
						}

						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT2, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							s_pSettings->pOnHookArg2 = DupString(szSetting);
						}
						//

						// ʘb{^(gvNbN)
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_OFFHOOK_PATH_EDIT3, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							s_pSettings->pOffHookCmd3 = DupString(szSetting);
						}

						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_OFFHOOK_OPTION_EDIT3, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							s_pSettings->pOffHookArg3 = DupString(szSetting);
						}
						//

						// Ib{^(gvNbN)
						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_ONHOOK_PATH_EDIT3, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							s_pSettings->pOnHookCmd3 = DupString(szSetting);
						}

						memset(szSetting, 0, sizeof(szSetting));
						GetDlgItemText(hDlg, IDC_ONHOOK_OPTION_EDIT3, szSetting, sizeof(szSetting)/sizeof(szSetting[0]));
						if (!IsBlankString(szSetting)) {
							s_pSettings->pOnHookArg3 = DupString(szSetting);
						}
						//

						// NbNԊu
						{
							TCHAR	szInterval[32];
							DWORD	dwInterval;

							memset(szInterval, 0, sizeof(szInterval));
							GetDlgItemText(hDlg, IDC_PRESS_INTERVAL, szInterval, sizeof(szInterval)/sizeof(szInterval[0]));
							if (!IsBlankString(szInterval)) {
								dwInterval = _ttol(szInterval);

								s_pSettings->dwPressInterval = dwInterval;
							}
							else {
								s_pSettings->dwPressInterval = HOOKKEYHOOK_DEFAULT_PERIOD;
							}
						}
						//

					}

					if (g_hwndCB2 != NULL) {
						CommandBar_Destroy(g_hwndCB2);
						g_hwndCB2 = NULL;
					}

					EndDialog(hDlg, LOWORD(wParam));
				}
				return TRUE;
				break;

			case IDCANCEL:
				if (g_hwndCB2 != NULL) {
					CommandBar_Destroy(g_hwndCB2);
					g_hwndCB2 = NULL;
				}
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
				break;

			case IDC_OFFHOOK_REF2:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_OFFHOOK_PATH_EDIT2, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;

			case IDC_ONHOOK_REF2:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_ONHOOK_PATH_EDIT2, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;

			case IDC_OFFHOOK_REF3:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_OFFHOOK_PATH_EDIT3, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;

			case IDC_ONHOOK_REF3:
				{
					TCHAR	szFileName[MAX_PATH + 1];

					memset(szFileName, 0, sizeof(szFileName));
					if (HKHGetFileName(hDlg, szFileName, sizeof(szFileName)/sizeof(szFileName[0]))) {
						SendDlgItemMessage(hDlg, IDC_ONHOOK_PATH_EDIT3, WM_SETTEXT, 0, (LPARAM)szFileName);
					}
				}
				return TRUE;
				break;

			}
			break;

	}
    return FALSE;
}